let data = [],
  side = 'right';

function initOptions() {
  let easeNames = Object.keys(d3).filter(
    (d) => d.slice(0, 4) === 'ease'
  );

  d3.select('select')
    .selectAll('option')
    .data(easeNames)
    .join('option')
    .attr('value', (d) => d)
    .text((d) => 'd3.' + d);

  d3.select('select').node().value =
    'easeCubicOut';
}

function updateData() {
  side = side === 'left' ? 'right' : 'left';
  data = [side === 'left' ? 100 : 700];
}

function update() {
  let easeName = d3.select('select').node().value;

  d3.select('svg')
    .selectAll('circle')
    .data(data)
    .join('circle')
    .attr('cy', 50)
    .attr('r', 40)
    .transition()
    .duration(750)
    .ease(d3[easeName])
    .attr('cx', (d) => d);
}

function updateAll() {
  updateData();
  update();
}

initOptions();
updateAll();
